# 1. Loading dataset
data(iris)

# 2. Exploratory Analysis
plot(iris[, 1:4], col = as.integer(iris$Species) + 1)
boxplot(Petal.Length ~ Species, data = iris, col = 3, main = "Petal.Length")

# 3. Modeling
library(rpart)
rp <- rpart(Species ~ ., iris)

# 4. Model checking
plot(rp, margin = 0.1, branch = 0.3)
text(rp, fancy = T, all = T, use.n = T)

# 5. Prediction and Validation
pred <- predict(rp, type = "class")
xtabs(~pred + iris$Species)
