package com.ef_prime.rflow;

import java.io.File;
import java.util.Locale;

import javax.swing.ImageIcon;

public class FileResource {
	

	public static final File SETTING_FILE = Constants.getUserFile("rflow.settings"); //$NON-NLS-1$
	public static final File FOLDERLOG_FILE = Constants.getUserFile("folderlog"); //$NON-NLS-1$
	public static File FUNCTION_FILE;
	public static final File USER_FUNCTION_FILE = Constants.getUserFile("function.xml"); //$NON-NLS-1$
	public static File CHTML_HELP_FILE;//for windows
	public static File JHELP_FILE;//for non windows
	public static File[] SAMPLE_FILE;
	public static File SAMPLE_FOLDER;
	
	/*-------------------------------------image-----------------------------------------*/

	public static final ImageIcon DESKTOP_16 = new ImageIcon(Constants.getPath("img/desktop_16.png")); //$NON-NLS-1$
	public static final ImageIcon SPLASH = new ImageIcon(Constants.getPath("img/R-flow-splash.png")); //$NON-NLS-1$

	public static final ImageIcon ACTION_NEW = new ImageIcon(Constants.getPath("img/action/new.png")); //$NON-NLS-1$
	public static final ImageIcon ACTION_REC = new ImageIcon(Constants.getPath("img/action/rec.png")); //$NON-NLS-1$
	public static final ImageIcon ACTION_RUN = new ImageIcon(Constants.getPath("img/action/run.png")); //$NON-NLS-1$
	public static final ImageIcon ACTION_SAVE = new ImageIcon(Constants.getPath("img/action/save.png")); //$NON-NLS-1$
	public static final ImageIcon ACTION_STOP = new ImageIcon(Constants.getPath("img/action/stop.png")); //$NON-NLS-1$
	
	public static final ImageIcon FLAG_IMAGE = new ImageIcon(Constants.getPath("img/node/flag.png")); //$NON-NLS-1$
	
	public static final ImageIcon BOX = new ImageIcon(Constants.getPath("img/node/box.png")); //$NON-NLS-1$
	
	public static final ImageIcon ERROR = new ImageIcon(Constants.getPath("img/error_16.png")); //$NON-NLS-1$
	public static final ImageIcon WARNING = new ImageIcon(Constants.getPath("img/warning_16.png")); //$NON-NLS-1$
	
	static
	{
		prepareFiles();
	}

	public static void prepareFiles(){
		/*
		 * file
		 */
		FUNCTION_FILE = Constants.getLocaleFile(new File(Constants.getPath("function.xml"))); //$NON-NLS-1$
		SAMPLE_FILE = new File[]{
				Constants.getLocaleFile(new File(Constants.getPath("sample/SampleAnalysis/BostonAnalysis.rflow"))), //$NON-NLS-1$
				Constants.getLocaleFile(new File(Constants.getPath("sample/SampleAnalysis/IrisAnalysis.rflow"))), //$NON-NLS-1$
				Constants.getLocaleFile(new File(Constants.getPath("sample/SampleAnalysis/script/IrisAnalysis.R"))), //$NON-NLS-1$
				Constants.getLocaleFile(new File(Constants.getPath("sample/Tutorial/BoxExample.rflow"))), //$NON-NLS-1$
				Constants.getLocaleFile(new File(Constants.getPath("sample/Tutorial/CacheExample.rflow"))), //$NON-NLS-1$
				Constants.getLocaleFile(new File(Constants.getPath("sample/Tutorial/NodeExample.rflow"))), //$NON-NLS-1$
		};
		SAMPLE_FOLDER = new File(Constants.getPath("sample"));
		
		CHTML_HELP_FILE = Constants.getLocaleFile(new File(Constants.getPath("help/chtml/htmlhelp.chm"))); //$NON-NLS-1$
		
		File jhelpFolder = new File(Constants.getPath("help/jhelp")); //$NON-NLS-1$
		String folder = "default"; //$NON-NLS-1$
		File[] langs = jhelpFolder.listFiles();
		if(langs != null){
			for(File f : jhelpFolder.listFiles())
				if(f.isDirectory() && f.getName().equals(Locale.getDefault().getLanguage()))
					folder = f.getName();
			JHELP_FILE = new File(Constants.getPath("help/jhelp/"+folder+"/jhelpset.hs")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		
	}
	
}
