package com.ef_prime.rflow.console;

import com.ef_prime.rflow.Constants;

public class BasicCommand extends AbstractCommand {
	
	private String command;
	private Command[] commands;

	public BasicCommand(String command){
		this(command, true);
	}
	
	public BasicCommand(String command, boolean split){
		//TODO split with newline is adequate
		//better parse with R, but ...
		if(split && command.contains(Constants.NEWLINE_STR)){
	    	String[] lines = command.split(Constants.NEWLINE_STR);
	    	if(lines.length > 1){
	    		commands = new Command[lines.length];
	    		for(int i = 0; i < lines.length; i++)
	    			commands[i] = new BasicCommand(lines[i], this);
	    	}else{
	    		this.command = command.trim();
	    	}
		}else{
    		this.command = command;
		}
	}
	
	public BasicCommand(BasicCommand[] commands){
		for(BasicCommand c : commands){
			c.setParent(this);
		}
		this.commands = commands;
	}
	
	private BasicCommand(String command, Command parent){
		this(command);
		setParent(parent);
	}

	public String getCommand() {
    	if(!command.endsWith(Constants.NEWLINE_STR))
    		command += Constants.NEWLINE_STR;
		return command;
	}
	
	public boolean hasCommand() {
		return command != null;
	}

	public Command[] getCommands() {
		return commands;
	}
	
	public int getCommandCount() {
		if(commands == null)
			return 0;
		else
			return commands.length;
	}

	public boolean print() {
		return true;
	}
}
