package com.ef_prime.rflow.console;

public interface Command {
	String getCommand();
	boolean hasCommand();
	Command[] getCommands();
	int getCommandCount();
	
	Command getParent();
	void setParent(Command parent);
	boolean isRoot();
	
	boolean print();
	
	boolean checkError();
	void setCheckError(boolean check);
	
	boolean isStarted();
	void start();
	boolean isFinished();
	void finish();
	boolean isCanceled();
	void cancel();
	boolean isErrorOccurred();
	void error();
	void waitForCommand();
	
	void addCommandListener(CommandListener listener);
	void removeCommandListener(CommandListener listener);
}
