package com.ef_prime.rflow.console;

/**
 * コマンドの終了（正常、異常問わず）のリスナーです
 * 以下のときに、commandEndedは呼び出されます
 * commandFinished
 * commandCanceled
 * errorOccurred
 */
public abstract class CommandEndListener implements CommandListener{

	public void commandCanceled(Command c) {
		commandEnded(c);
	}

	public void commandFinished(Command c) {
		commandEnded(c);
	}

	public void commandStart(Command c) {
	}

	public void errorOccurred(Command c) {
		commandEnded(c);
	}
	
	/**
	 * 以下のときに、commandEndedは呼び出されます
	 * commandFinished
	 * commandCanceled
	 * errorOccurred
	 * @param c
	 */
	public abstract void commandEnded(Command c);
}
