package com.ef_prime.rflow.console;

import java.util.LinkedList;
import java.util.Queue;

import com.ef_prime.rflow.Rflow;

public class CommandReceiver {
	
	private Rflow rflow;
	
	private Queue<Command> commands = new LinkedList<Command>();
	
	private boolean commandArrived = false;
	
	public CommandReceiver(Rflow rflow){
		this.rflow = rflow;
	}
	
    public synchronized Command waitForCommand() {
        
    	while (!commandArrived) {
            try {
                wait(50);
				rflow.R.rniIdle();
            } catch (InterruptedException e) {
            }
        }
        
    	Command c=null;
        if (!commands.isEmpty()) {
        	c = commands.poll();
        }
        if (commands.isEmpty())
        	commandArrived=false;
        
        if(!c.hasCommand()){
        	c.finish();
        	return waitForCommand();
        }
        return c;
    }
    
    public synchronized void passCommand(String command) {
    	passCommand(new BasicCommand(command));
    }

    public synchronized void passCommand(Command command) {
    	for(int i = 0; i < command.getCommandCount(); i++){
    		passCommand(command.getCommands()[i]);
    	}
    	//if(command.hasCommand()){
        	commandArrived=true;
            commands.offer(command);
            notifyAll();
    	//}
    }
    
    public synchronized void discardAllCommand(){
    	commands.clear();
    	commandArrived = false;
    }
}
