package com.ef_prime.rflow.explorer;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import com.ef_prime.rflow.Rflow;
import com.ef_prime.rflow.object.ObjectBrowser;
import com.ef_prime.rflow.resource.Messages;

public class Explorer extends JPanel{
	
	private JTabbedPane tabbedPane;

	private FileExplorer fileExplorer;
	private FunctionExplorer functionExplorer;
	private HierarchyExplorer hierarchyExplorer;
	private ObjectBrowser objectBrowser;
	
	public Explorer(Rflow rflow){
		super();
		setLayout(new BorderLayout());
		
		fileExplorer = new FileExplorer(rflow);
		functionExplorer = new FunctionExplorer(rflow);
		hierarchyExplorer = new HierarchyExplorer(rflow);
		
		tabbedPane = new JTabbedPane();
		tabbedPane.add(fileExplorer, Messages.getString("Explorer.file")); //$NON-NLS-1$
		tabbedPane.add(functionExplorer, Messages.getString("Explorer.function")); //$NON-NLS-1$
		//tabbedPane.add(new PartsExplorerPanel(rflow), "パーツ");
		tabbedPane.add(hierarchyExplorer, Messages.getString("Explorer.hierarchy")); //$NON-NLS-1$
		objectBrowser = new ObjectBrowser();
		tabbedPane.add(objectBrowser, Messages.getString("Explorer.objects")); //$NON-NLS-1$
		
		add(tabbedPane);
	}
	
	public void init(){
		hierarchyExplorer.update();
		objectBrowser.update();
	}
	
	public FunctionExplorer getFunctionExplorer() {
		return functionExplorer;
	}
	
	public FileExplorer getFileExplorer() {
		return fileExplorer;
	}
	
	public HierarchyExplorer getHierarchyExplorer(){
		return hierarchyExplorer;
	}
	
	public ObjectBrowser getObjectBrowser() {
		return objectBrowser;
	}
	
	/*public PartsExplorerPanel getPartsExplorerPanel() {
		return (PartsExplorerPanel)tabbedPane.getComponent(1);
	}*/
}
