package com.ef_prime.rflow.explorer;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.ef_prime.rflow.tool.MutableTreeNodeFlavor;

public class FileNodeTransferable implements Transferable{

	private FileNode[] nodes;
	
	DataFlavor[] flavors = new DataFlavor[]{
			MutableTreeNodeFlavor.getInstance(),
			DataFlavor.javaFileListFlavor
			};

	public FileNodeTransferable(FileNode[] nodes) {
		super();
		this.nodes = nodes.clone();
	}
	
	public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
		if (flavor.equals(flavors[0])) {
		    return nodes.clone();
		} else if(flavor.equals(flavors[1])) {
			List<File> list = new ArrayList<File>();
			for(FileNode node : nodes)
				list.add(node.getFile());
			return list;
		} else {
		    throw new UnsupportedFlavorException(flavor);
		}
	}

	public DataFlavor[] getTransferDataFlavors() {
		return (DataFlavor[])flavors.clone();
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		 for (int i = 0; i < flavors.length; i++) {
			    if (flavor.equals(flavors[i])) {
			        return true;
			    }
			}
		return false;
	}


}

