package com.ef_prime.rflow.explorer;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

import com.ef_prime.rflow.tool.MutableTreeNodeFlavor;

public class FunctionNodeTransferable implements Transferable{

	private FunctionNode[] nodes;
	
	DataFlavor[] flavors = new DataFlavor[]{
			FunctionNodeFlavor.getInstance(),
			MutableTreeNodeFlavor.getInstance()
			};

	public FunctionNodeTransferable(FunctionNode[] nodes) {
		super();
		this.nodes = nodes.clone();
	}
	
	public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
		if (flavor.equals(flavors[0]) || flavor.equals(flavors[1])) {
		    return nodes.clone();
		} else {
		    throw new UnsupportedFlavorException(flavor);
		}
	}

	public DataFlavor[] getTransferDataFlavors() {
		return (DataFlavor[])flavors.clone();
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		 for (int i = 0; i < flavors.length; i++) {
			    if (flavor.equals(flavors[i])) {
			        return true;
			    }
			}
		return false;
	}


}

