package com.ef_prime.rflow.flow;

import java.io.File;
import java.text.DecimalFormat;
import java.util.GregorianCalendar;

public class CacheData {
	
	private File file;
	private String command;
	//private String hash;
	private GregorianCalendar date;
	private long size;
	private boolean isValid;
	private boolean flagExists = true;
	
	
	public CacheData(File file, String command, GregorianCalendar date,
			long size, boolean isValid) 
	{
		super();
		this.file = file;
		this.command = command;
		//this.hash = hash;
		this.date = date;
		this.size = size;
		this.isValid = isValid;
	}
	
	/**
	 * コピー用コンストラクタ
	 * @param file
	 * @param command
	 * @param hash
	 * @param date
	 * @param size
	 * @param isValid
	 * @param flagExists
	 */
	private CacheData(CacheData data) 
	{
		this(data.file, data.command, data.date, data.size, data.isValid);
		if(data.date != null)
			this.date = (GregorianCalendar)data.date.clone();
		this.flagExists = data.flagExists;
	}

	public GregorianCalendar getDate() {
		return date;
	}

	/*public String getHash() {
		return hash;
	}*/

	public File getFile() {
		return file;
	}
	
	public String getCommand() {
		return command;
	}
	
	public long getSize() {
		return size;
	}
	
	public boolean isSize(){
		return size != 0L;
	}

	/*public boolean isHash(){
		return hash != null;
	}*/
	
	public boolean isDate(){
		return date != null;
	}
	
	public boolean isCommand(){
		return command != null;
	}
	
	public void setSize(long lastModified) {
		this.size = lastModified;
	}
	
	public void setValid(boolean isValid) {
		this.isValid = isValid;
	}
	
	public boolean isValid() {
		return isValid;
	}
	
	public void setFlagExists(boolean flagExists) {
		this.flagExists = flagExists;
	}
	
	public boolean flagExists() {
		return flagExists;
	}
	
	
	private static final DecimalFormat twoDigitFormat = new DecimalFormat("00"); //$NON-NLS-1$
	public static String toString(GregorianCalendar date){
		if(date == null)return null;
		//YYYYMMDDHHMMSS
		String s = String.valueOf(date.get(GregorianCalendar.YEAR));
		s += twoDigitFormat.format((date.get(GregorianCalendar.MONTH)+1));
		s += twoDigitFormat.format(date.get(GregorianCalendar.DATE));
		s += twoDigitFormat.format(date.get(GregorianCalendar.HOUR_OF_DAY));
		s += twoDigitFormat.format(date.get(GregorianCalendar.MINUTE));
		s += twoDigitFormat.format(date.get(GregorianCalendar.SECOND));
		return s;
	}
	
	public static GregorianCalendar parseDate(String yyyymmddhhmmss){
		if(yyyymmddhhmmss == null)return null;
		int year = Integer.parseInt(yyyymmddhhmmss.substring(0, 4));
		int month = Integer.parseInt(yyyymmddhhmmss.substring(4, 6)) - 1;
		int date = Integer.parseInt(yyyymmddhhmmss.substring(6, 8));
		int hour = Integer.parseInt(yyyymmddhhmmss.substring(8, 10));
		int minute = Integer.parseInt(yyyymmddhhmmss.substring(10, 12));
		int second = Integer.parseInt(yyyymmddhhmmss.substring(12, 14));
		return new GregorianCalendar(year, month, date, hour, minute, second);
	}
	
	public CacheData copy(){
		return new CacheData(this);
	}
}
