package com.ef_prime.rflow.flow;

import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;

import edu.uci.ics.jung.visualization.VisualizationViewer;
import edu.uci.ics.jung.visualization.control.TranslatingGraphMousePlugin;
import edu.uci.ics.jung.visualization.transform.MutableTransformer;

public class FlowTranslatingGraphMousePlugin extends TranslatingGraphMousePlugin {

	public FlowTranslatingGraphMousePlugin() {
		super();
	}

	public FlowTranslatingGraphMousePlugin(int modifiers) {
		super(modifiers);
	}
	
	
	@Override
	public void mouseDragged(MouseEvent e) {
        VisualizationViewer vv = (VisualizationViewer)e.getSource();
        boolean accepted = checkModifiers(e);
        if(accepted) {
            MutableTransformer modelTransformer = vv.getLayoutTransformer();
            vv.setCursor(cursor);
            try {
                Point2D q = vv.inverseTransform(down);
                Point2D p = vv.inverseTransform(e.getPoint());
                float dx = (float) (p.getX()-q.getX());
                float dy = (float) (p.getY()-q.getY());
                
                modelTransformer.translate(dx, dy);
                down.x = e.getX();
                down.y = e.getY();
                
                
                ((FlowViewer)vv).setDirty(true);
                
            } catch(RuntimeException ex) {
                System.err.println("down = "+down+", e = "+e); //$NON-NLS-1$ //$NON-NLS-2$
                throw ex;
            }
        
            e.consume();
        }
	}
}
