package com.ef_prime.rflow.flow;

import javax.swing.event.UndoableEditEvent;
import javax.swing.undo.CannotRedoException;
import javax.swing.undo.CannotUndoException;
import javax.swing.undo.UndoManager;
import javax.swing.undo.UndoableEdit;

import com.ef_prime.rflow.Rflow;
import com.ef_prime.rflow.flow.model.FlowNode;

public class FlowUndoManager extends UndoManager{
	
	private final Rflow rflow;
	private boolean working;
	
	FlowUndoManager(Rflow rflow){
		this.rflow = rflow;
	}
	
	
	@Override
	public synchronized void undo() throws CannotUndoException {
		working = true;
		try{
			super.undo();
		}finally{
			working = false;
		}
	}
	
	@Override
	public synchronized void redo() throws CannotRedoException {
		working = true;
		try{
			super.redo();
		}finally{
			working = false;
		}
	}
	
	
	@Override
	public void undoableEditHappened(UndoableEditEvent e) {
		if(working)return;
		super.undoableEditHappened(e);
		rflow.actionManager.updateUndoState();
	}
	
	public void removeOldClearCacheEdit(FlowNode node){
		for(UndoableEdit edit : edits){
			if(edit instanceof DefaultUndoableEdits.ClearCacheEdit){
				//TODO replace edit with null edit
				DefaultUndoableEdits.ClearCacheEdit ccEdit = (DefaultUndoableEdits.ClearCacheEdit)edit;
				if(ccEdit.getNode() == node){
					ccEdit.setInsignificant();
				}
			}
		}
	}
	
	public void undoNewNodeCreation(FlowNode node){
		if(lastEdit() instanceof DefaultUndoableEdits.NewNodeEdit){
			DefaultUndoableEdits.NewNodeEdit edit = (DefaultUndoableEdits.NewNodeEdit)lastEdit();
			if(edit.getNode() == node){
				undo();
				rflow.actionManager.updateUndoState();
			}
		}
	}
}
