package com.ef_prime.rflow.flow;

import javax.swing.undo.CompoundEdit;
import javax.swing.undo.UndoableEdit;
import javax.swing.undo.UndoableEditSupport;

public class FlowUndoableEditSupport extends UndoableEditSupport{
	
	boolean beginOnce = false;
	
	public FlowUndoableEditSupport(Object r) {
		super(r);
	}
	

	public synchronized void beginUpdateOnce() {
		beginOnce = true;
		if(updateLevel > 0)
			return;
		else
			super.beginUpdate();
	}

	public synchronized void beginUpdate(CompoundEdit edit) {
		if (updateLevel == 0) {
		    compoundEdit = edit;
		}
		updateLevel++;
	}
	
	@Override
	public synchronized void endUpdate() {
		if(updateLevel < 1)
			return;
		else
			super.endUpdate();
	}
	
	@Override
	public synchronized void postEdit(UndoableEdit e) {
		super.postEdit(e);
		if(compoundEdit != null && beginOnce && e.isSignificant()){
			endUpdate();
			beginOnce = false;
		}
	}
}
