package com.ef_prime.rflow.flow;

import java.awt.Image;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;


public class LayoutTransferable implements Transferable{

	private ViewLayout layout;
	private Image layoutImage;
	
	public LayoutTransferable(ViewLayout layout, Image layoutImage){
		this.layout = layout;
		this.layoutImage = layoutImage;
	}
	
	DataFlavor[] flavors = new DataFlavor[]{
			LayoutDataFlavor.getInstance(),
			DataFlavor.imageFlavor
	};
	
	public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
		if (flavor.equals(flavors[0])) {
		    return layout;
		} else if(flavor.equals(flavors[1])){
			return layoutImage;
		} else {
		    throw new UnsupportedFlavorException(flavor);
		}
	}

	public DataFlavor[] getTransferDataFlavors() {
		return (DataFlavor[])flavors.clone();
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		 for (int i = 0; i < flavors.length; i++) {
			    if (flavor.equals(flavors[i])) {
			        return true;
			    }
			}
		return false;
	}

}
