package com.ef_prime.rflow.flow;

import com.ef_prime.rflow.flow.model.FlowNode;
import com.ef_prime.rflow.util.ObjectUtilities;

public class NodeSelectionInfo {
	private FlowNode in;
	private FlowNode out;

	private FlowNode source;

	public NodeSelectionInfo(FlowNode in, FlowNode out, FlowNode source) {
		if(source == null)
			throw new IllegalArgumentException("source can't be null."); //$NON-NLS-1$
		
		this.in = in;
		this.out = out;
		this.source = source;
	}

	public FlowNode getIn() {
		return in;
	}

	public FlowNode getOut() {
		return out;
	}

	public FlowNode getSource() {
		return source;
	}
	
	public FlowNode getLast(){
		return (getOut() == null)?null:(FlowNode)getOut().getPredecessors().iterator().next();
	}
	
	@Override
	public int hashCode() {
		int hash = 0;
		if(in != null)
			hash += in.hashCode();
		if(out != null)
			hash += out.hashCode();
		hash += source.hashCode();
		return hash;
	}
	
	@Override
	public boolean equals(Object obj) {
		if(this == obj)return true;
		if(!(obj instanceof NodeSelectionInfo))return false;
		NodeSelectionInfo info = (NodeSelectionInfo)obj;
		return 	ObjectUtilities.equals(in, info.getIn())
				&& ObjectUtilities.equals(out, info.getOut())
				&& ObjectUtilities.equals(source, info.getSource());
	}
}
