package com.ef_prime.rflow.flow.rendering;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Paint;
import java.awt.Shape;
import java.awt.Stroke;

import com.ef_prime.rflow.flow.FlowState;

import edu.uci.ics.jung.graph.Edge;
import edu.uci.ics.jung.graph.decorators.EdgePaintFunction;
import edu.uci.ics.jung.graph.decorators.EdgeShape;
import edu.uci.ics.jung.graph.decorators.EdgeShapeFunction;
import edu.uci.ics.jung.graph.decorators.EdgeStrokeFunction;

public class EdgeRendering implements EdgePaintFunction, EdgeShapeFunction, EdgeStrokeFunction{

	private static final Paint DRAW_PAINT = new Color(0.3f, 0.3f, 0.3f);
	private static final Paint DRAW_PAINT_LIGHT = new Color(0.8f, 0.8f, 0.8f);
	private static final Paint PICKED_DRAW_PAINT = Color.cyan;
	private static final Paint INSERT_TARGET_PAINT = Color.RED;
	//private static final Paint pickedEdgePaintLight = new Color(0,150,150);
	private static final Stroke EDGE_STROKE = new BasicStroke(1.5f);
	
	private static final EdgeShapeFunction lineEdgeShapeFunction = new EdgeShape.Line();
	
	private FlowState state;
	
	public EdgeRendering(FlowState pickedInfo){
		this.state = pickedInfo; 
	}
	
	public Paint getDrawPaint(Edge e) {
		if(e.equals(state.getInsertTargetEdge())){
			return INSERT_TARGET_PAINT;
		}
		else if(state.isPicked(e)){
			return PICKED_DRAW_PAINT;
			//return new Color(230,230,0);
		}
		else if(state.isFlowSelected())
		{
			if(state.getSelectionEdgeFlow().contains(e))
				return Color.ORANGE;
//				return new Color(0, 204, 102);
//				return Color.RED;
				//return new Color(255, 102, 0, 200);
//				return Color.BLACK;
			else
//				return DRAW_PAINT;
				return DRAW_PAINT_LIGHT;
		}
		else{
			//return new Color(0,0,0,150);
			return DRAW_PAINT;
		}
	}

	public Paint getFillPaint(Edge e) {
		return null;
	}

	public Shape getShape(Edge e) {
		return lineEdgeShapeFunction.getShape(e);
	}

	public Stroke getStroke(Edge e) {
		return EDGE_STROKE;
	}

}
