package com.ef_prime.rflow.group;

import java.awt.Shape;

import javax.swing.Icon;
import javax.swing.ImageIcon;

public abstract class AppearanceGroup {
	private String title;
	
	AppearanceGroup(String title) {
		this.title = title;
	}

	public String getTitle() {
		return title;
	}

	public abstract ImageIcon getIcon();
	
	public abstract Icon getSmallIcon();
	
	public abstract Shape getShape();
	
	public abstract Shape getGlassShape();

	@Override
	public int hashCode() {
		return title.hashCode();
	}
	
	@Override
	public String toString() {
		return getTitle();
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof AppearanceGroup) {
			AppearanceGroup fg = (AppearanceGroup) obj;
			return title.equals(fg.title);
		}
		return false;
	}
}
