package com.ef_prime.rflow.group;

import java.util.LinkedHashSet;
import java.util.Set;

import com.ef_prime.rflow.Constants;
import com.ef_prime.rflow.flow.rendering.NodeShape;
import com.ef_prime.rflow.resource.Messages;

public enum DefaultAppearanceGroup {
	
	
	INPUT(Messages.getString("FunctionGroup.input"), Constants.getPath("img/node/input.png")), //$NON-NLS-1$ //$NON-NLS-2$
	OUTPUT(Messages.getString("FunctionGroup.output"), Constants.getPath("img/node/output.png")), //$NON-NLS-1$ //$NON-NLS-2$
	MODELING(Messages.getString("FunctionGroup.modeling"), Constants.getPath("img/node/modeling.png")), //$NON-NLS-1$ //$NON-NLS-2$
	PREDICTION(Messages.getString("FunctionGroup.predict"), Constants.getPath("img/node/prediction.png")), //$NON-NLS-1$ //$NON-NLS-2$
	RANDOM(Messages.getString("FunctionGroup.random"), Constants.getPath("img/node/random.png")), //$NON-NLS-1$ //$NON-NLS-2$
	

	//CIRCLE(NodeShape.CIRCLE),
	//TRIANGLE(NodeShape.TRIANGLE),
	//RECTANGLE(NodeShape.RECTANGLE),
	STAR(NodeShape.STAR)
	
	;

	private AppearanceGroup group;

	private static Set<AppearanceGroup> defaultGroups;
	
	static{
		LinkedHashSet<AppearanceGroup> set = new LinkedHashSet<AppearanceGroup>();
		for(DefaultAppearanceGroup dap : DefaultAppearanceGroup.values()){
			set.add(dap.getAppearanceGroup());
		}
		defaultGroups = set;
	}
	
	private DefaultAppearanceGroup(NodeShape shape){
		group = new ShapeAppearanceGroup(shape.getName(), shape);
	}
	
	private DefaultAppearanceGroup(String title, String iconPath){
		group = new IconAppearanceGroup(title, iconPath);
	}
	
	
	public AppearanceGroup getAppearanceGroup() {
		return group;
	}
	
	public static AppearanceGroup[] getAppearanceGroups(){
		return defaultGroups.toArray(new AppearanceGroup[defaultGroups.size()]);
	}
	
	public static DefaultAppearanceGroup valueOf(AppearanceGroup group){
		for(DefaultAppearanceGroup dap : DefaultAppearanceGroup.values()){
			if(dap.getAppearanceGroup().equals(group))
				return dap;
		}
		return null;//?exception
	}
}
