package com.ef_prime.rflow.group;

import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Shape;
import java.io.File;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import com.ef_prime.rflow.Constants;

public class IconAppearanceGroup extends AppearanceGroup{

	private String iconPath;
	private ImageIcon icon;
	private Icon smallIcon;
	private Shape iconShape;
	private Shape glassShape;
	
	public IconAppearanceGroup(String title, String iconPath) {
		super(title);
		this.iconPath = iconPath;
		this.icon = new ImageIcon(
				(new File(iconPath).isAbsolute())?iconPath:Constants.getPath(iconPath));
		int w = icon.getIconWidth();
		int h = icon.getIconHeight();
		this.smallIcon = new ImageIcon(icon.getImage().getScaledInstance(16, 16, Image.SCALE_SMOOTH));
		int space = 5;
		this.iconShape = new Rectangle(-w/2, -h/2, w, h);
		this.glassShape = new Rectangle(-w/2-space, -h/2-space, w+space*2, h+space*2+10);
	}

	public String getIconPath() {
		return iconPath;
	}
	
	@Override
	public ImageIcon getIcon() {
		return icon;
	}

	@Override
	public Icon getSmallIcon() {
		return smallIcon;
	}
	
	@Override
	public Shape getShape() {
		return iconShape;
	}

	@Override
	public Shape getGlassShape() {
		return glassShape;
	}
	
}
