package com.ef_prime.rflow.group;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import com.ef_prime.rflow.flow.rendering.NodeRendering;
import com.ef_prime.rflow.flow.rendering.NodeShape;

public class ShapeAppearanceGroup extends AppearanceGroup{

	private NodeShape nodeShape;
	private Icon smallIcon;
	
	public ShapeAppearanceGroup(String title, NodeShape nodeShape) {
		super(title);
		this.nodeShape = nodeShape;
		
		Shape s = getShape();
		Rectangle rect = s.getBounds();
		BufferedImage image = new BufferedImage(rect.width, rect.height, BufferedImage.TYPE_INT_ARGB);
		Graphics2D g = (Graphics2D)image.getGraphics();
		s = AffineTransform.getTranslateInstance(-rect.x, -rect.y).createTransformedShape(s);
		g.setPaint(NodeRendering.FILLPAINT);
		g.fill(s);
		
		smallIcon = new ImageIcon(image.getScaledInstance(16, 16, Image.SCALE_SMOOTH));
		image.flush();
		
	}
	
	public NodeShape getNodeShape(){
		return nodeShape;
	}

	@Override
	public ImageIcon getIcon() {
		return null;
	}

	@Override
	public Icon getSmallIcon() {
		return smallIcon;
	}

	@Override
	public Shape getShape() {
		return nodeShape.getShape();
	}

	@Override
	public Shape getGlassShape() {
		return NodeShape.getGlassShape();
	}
}
