package com.ef_prime.rflow.node;

import java.awt.Component;

import javax.swing.JTabbedPane;

import com.ef_prime.rflow.exception.InvalidOptionException;

public abstract class AbstractNodeOptionPanelHandler implements NodeOptionPanelHandler{
	
	protected JTabbedPane tabPane;

	public final JTabbedPane getNodeOptionTabbedPane(NodeModel orginalModel) {
		if(tabPane == null){
			tabPane = new JTabbedPane();
			NodeOptionPanel[] pnls = createNodeOptionPanels(orginalModel);
			for(NodeOptionPanel panel : pnls)
				tabPane.add(panel, panel.getTitle());
			initTabbedPane();
		}
		return tabPane;
	}
	
	protected abstract NodeOptionPanel[] createNodeOptionPanels(NodeModel orginalModel);
	
	protected void initTabbedPane(){
		
	}

	public void initFocus() {
		Component c = tabPane.getComponentAt(0);
		if (c instanceof NodeOptionPanel) {
			NodeOptionPanel panel = (NodeOptionPanel) c;
			panel.initFocus();
		}
	}

	public NodeModel getModel() throws InvalidOptionException {
		Component c = tabPane.getComponentAt(0);
		if (c instanceof NodeOptionPanel) {
			NodeOptionPanel panel = (NodeOptionPanel) c;
			return panel.getModel();
		}
		throw new RuntimeException("component in tab must be NodeOptionPanel"); //$NON-NLS-1$
	}
	
}
