package com.ef_prime.rflow.node;

import java.awt.Window;
import java.util.Properties;

import com.ef_prime.rflow.exception.ModelCreationFailedException;
import com.ef_prime.rflow.flow.FlowViewer;
import com.ef_prime.rflow.flow.ViewLayout;
import com.ef_prime.rflow.flow.model.FlowNode;

public interface NodeModelController {
	
	String getModelName();
	
	Class<? extends NodeModel> getModelClass();
	
	/**
	 * 新しいモデルを作成する
	 * @return
	 */
	NodeModel createNewModel();
	
	/**
	 * 
	 * @param node
	 * @param selectProperty TODO
	 * @return dialog to edit node. null if edit not supported.
	 */
	Window createEditDialog(FlowViewer viewer, FlowNode node, boolean selectProperty, boolean isNewNode);
	
	/**
	 * modelの設定Propertiesをかえす
	 * @param model
	 * @return
	 */
	Properties getOptionProperties(NodeModel model);
	
	NodeModel createModel(Properties properties, String command, ViewLayout[] subflows) throws ModelCreationFailedException;

	//boolean checkModelClass(NodeModel model);
	
	boolean isAddable();
}
