package com.ef_prime.rflow.node;

import java.io.File;

import com.ef_prime.rflow.Constants;
import com.ef_prime.rflow.RCommand;
import com.ef_prime.rflow.exception.IncompatibleCommandException;
import com.ef_prime.rflow.node.base.ArgEntry;
import com.ef_prime.rflow.node.base.ArgListMod;
import com.ef_prime.rflow.node.base.SentenceNodeModel;
import com.ef_prime.rflow.util.ExtensionUtility;
import com.ef_prime.rflow.util.FileUtility;

//TODO 登録型にする
public class NodeModelFactory {
	
	
	public static boolean isModelCreationSupported(File file){

		String name = file.getName().toLowerCase();
		
		if(name.endsWith(".csv"))return true; //$NON-NLS-1$
		if(name.endsWith(".txt"))return true; //$NON-NLS-1$
		if(name.endsWith(".r"))return true; //$NON-NLS-1$
		if(name.endsWith(".rdata"))return true; //$NON-NLS-1$
		return false;
	}
	
	public static SentenceNodeModel createNodeModel(File file, File parent){
		String name = file.getName().toLowerCase();
		
		String symbol = ""; //$NON-NLS-1$
		String function = ""; //$NON-NLS-1$
		ArgListMod argList = new ArgListMod();
		if(name.endsWith(".csv")){ //$NON-NLS-1$
			function = "read.csv"; //$NON-NLS-1$
			symbol = ExtensionUtility.removeExtension(file.getName());
		}else if(name.endsWith(".txt")){ //$NON-NLS-1$
			function = "read.table"; //$NON-NLS-1$
			symbol = ExtensionUtility.removeExtension(file.getName());
		}else if(name.endsWith(".r")){ //$NON-NLS-1$
			function = "source"; //$NON-NLS-1$
		}else if(name.endsWith(".rdata")){ //$NON-NLS-1$
			function = "load"; //$NON-NLS-1$
		}else{
			return null;
		}
		
		//symbol = Constants.getVarName(symbol);
		symbol = RCommand.makenames(symbol);
		if(symbol == null)symbol = "x";
		
		String path = FileUtility.makeAbstractPath(parent, file).getPath();
		argList.add(new ArgEntry("file",  //$NON-NLS-1$
				Constants.quote(Constants.replaceFileSeparator(path))));

		SentenceInfo info = new SentenceInfo(symbol, function, false, argList);
		SentenceNodeModel model = new SentenceNodeModel();
		try {
			model.setCommand(info.getLine());
		} catch (IncompatibleCommandException e) {
			e.printStackTrace();
			return null;
		}
		return model;
	}
	
}
