package com.ef_prime.rflow.node;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class NodeModelManager {
	
	private static final Map<Class<? extends NodeModel>, NodeModelController> modelMap
		= new LinkedHashMap<Class<? extends NodeModel>, NodeModelController>();
	//private static final List<NodeModelGetter> modelGetterList = new ArrayList<NodeModelGetter>();

	public static List<NodeModelController> getModelControllerList() {
		ArrayList<NodeModelController> list  = new ArrayList<NodeModelController>();
		for(NodeModelController getter : modelMap.values()){
			if(getter != null)
				list.add(getter);
		}
		return list;
	}
	
	public static void addNodeModel(Class<? extends NodeModel> modelClass, NodeModelController getter){
		modelMap.put(modelClass, getter);
	}
	
	public static void addNodeModel(NodeModelController getter){
		modelMap.put(getter.getModelClass(), getter);
	}
	
	public static NodeModelController getModelController(Class<? extends NodeModel> modelClass){
		NodeModelController getter = modelMap.get(modelClass);
		if(getter == null)
			return null;
		else
			return getter;
	}
	
	public static NodeModelController getModelController(String className){
		for(Class<? extends NodeModel> modelClass : modelMap.keySet()){
			if(modelClass.getCanonicalName().equals(className))
				return modelMap.get(modelClass);
		}
		return null;
	}
	
	public static boolean containsModel(Class<? extends NodeModel> modelClass){
		return modelMap.containsKey(modelClass);
	}
	
}
