package com.ef_prime.rflow.node;

import com.ef_prime.rflow.group.AppearanceGroup;
import com.ef_prime.rflow.util.ObjectUtilities;

public class NodeProperty {

	/** 
	 * タイトル
	 * nullならば既定のタイトル
	 */
	private String title;
	
	/**
	 * 形
	 * nullならば既定の形
	 */
	private AppearanceGroup group;
	
	/** コメント */
	private String comment;
	
	public NodeProperty(){
		
	}
	
	/**
	 * コピー用コンストラクタ
	 */
	private NodeProperty(NodeProperty property){
		title = property.getTitle();
		group = property.getAppearanceGroup();
		comment = property.getComment();
	}
	
	public static NodeProperty createDefaultProperty(){
		return new NodeProperty();
	}
	
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	public AppearanceGroup getAppearanceGroup(){
		return group;
	}
	public void setAppearanceGroup(AppearanceGroup group){
		this.group = group;
	}
	
	public String getComment(){
		return comment;
	}
	public void setComment(String comment){
		this.comment = comment;
	}
	
	public NodeProperty copy(){
		return new NodeProperty(this);
	}
	
	
	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((title == null) ? 0 : title.hashCode());
		result = PRIME * result + ((comment == null) ? 0 : comment.hashCode());
		result = PRIME * result + ((group == null) ? 0 : group.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if(!(obj instanceof NodeProperty))
			return false;
		NodeProperty np = (NodeProperty)obj;

		return  
		ObjectUtilities.equals(getTitle(), np.getTitle())
		&&
		ObjectUtilities.equals(getComment(), np.getComment())
		&&
		ObjectUtilities.equals(getAppearanceGroup(), np.getAppearanceGroup());
	}
}
