package com.ef_prime.rflow.node;

import com.ef_prime.rflow.node.base.ArgListMod;

public class SentenceInfo {
	private String line;
	private String symbol;
	private String function;
	private boolean isControl;
	private ArgListMod argList;

	public SentenceInfo(String line, String symbol, String function,
			boolean isControl, ArgListMod argList) 
	{
		super();
		this.line = line;
		this.symbol = symbol;
		this.function = function;
		this.isControl = isControl;
		this.argList = argList;
	}
	
	/**
	 * auto generate line field
	 * @param symbol
	 * @param function
	 * @param isControl
	 * @param argList
	 */
	public SentenceInfo(String symbol, String function, boolean isControl, 
			ArgListMod argList)
	{
		this.symbol = symbol;
		this.function = function;
		this.isControl = isControl;
		this.argList = argList;
		
		line = ""; //$NON-NLS-1$
		if(isAssign())
			line += symbol + " <- "; //$NON-NLS-1$
		if(isFunction())
			line += function + argList.toArgString();
	}

	
	public ArgListMod getArgList() {
		return (ArgListMod)argList.clone();
	}

	public String getFunction() {
		return function;
	}

	public String getLine() {
		return line;
	}
	
	public boolean isControl() {
		return isControl;
	}

	public String getSymbol() {
		return symbol;
	}
	
	public boolean isFunction(){
		return !function.equals(""); //$NON-NLS-1$
	}
	
	public boolean isAssign(){
		return !symbol.equals(""); //$NON-NLS-1$
	}
}
