package com.ef_prime.rflow.node.base;


//imutable
public class ArgEntry {
	private String param;
	private String value;
	
	public ArgEntry(String param, String value) {
		super();
		if(param == null)throw new IllegalArgumentException("param can't be null"); //$NON-NLS-1$
		if(value == null)throw new IllegalArgumentException("value can't be null"); //$NON-NLS-1$
		this.param = param;
		this.value = value;
	}
	
	public boolean isParam(){
		return !param.equals(""); //$NON-NLS-1$
	}
	
	public boolean isValue(){
		return !value.equals(""); //$NON-NLS-1$
	}
	
	
	public String getParam() {
		return param;
	}
	
	
	public String getValue() {
		return value;
	}

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + param.hashCode();
		result = PRIME * result + value.hashCode();
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final ArgEntry other = (ArgEntry) obj;
		if (!param.equals(other.param))
			return false;
		if (!value.equals(other.value))
			return false;
		return true;
	}
	
	@Override
	public String toString() {
		if(isParam())
			return param+" = "+value; //$NON-NLS-1$
		else
			return value;
	}
}
