package com.ef_prime.rflow.node.base;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class ArgList extends LinkedHashMap<String, String>{
	private LinkedHashMap<String, String> defaultMap;

	public ArgList(LinkedHashMap<String, String> defaultMap) {
		this.defaultMap = defaultMap;
	}
	
	public String getValue(String param) {
		String value = (String)get(param);
		if(value == null)
			return defaultMap.get(param);
		else
			return value;
	}
	
	public synchronized String putArgument(String param, String value) {
		String v = defaultMap.get(param);
		if(v != null && v.equals(value))
			return v;
		return put(param, value);
	}
	
	public Map<String, String> getDefaultMap(){
		return defaultMap;
	}
	
	public Iterator<String> paramIterator(){
		return new Iterator<String>(){

			private Iterator<String> iterator = defaultMap.keySet().iterator();
			private Set<Object> keys = new HashSet<Object>(keySet());
			private Iterator<Object> keyIterator = null;
			
			public boolean hasNext() {
				if(iterator.hasNext()){
					return true;
				}else if(keyIterator == null){
					keyIterator = keys.iterator();
				}
				return keyIterator.hasNext();
			}

			public String next() {
				if(keyIterator == null){
					String param = iterator.next();
					keys.remove(param);
					return param;
				}
				return (String)keyIterator.next();
			}

			public void remove() {
				if(keyIterator == null){
					iterator.remove();
				}else{
					keyIterator.remove();
				}
			}
		};
	}
	
	public List<ArgEntry> getArgList(){
		List<ArgEntry> list = new ArrayList<ArgEntry>();
		Iterator<String> ite = paramIterator();
		while(ite.hasNext()){
			String param = ite.next();
			String value = getValue(param);
			list.add(new ArgEntry(param, value));
		}
		return list;
	}
	
	public String list(boolean withDefaults){
		String list = "("; //$NON-NLS-1$
		Iterator<String> ite = paramIterator();
		while(ite.hasNext()){
			String param = ite.next();
			String value;
			if(withDefaults){
				value = getValue(param);
			}else{
				value = (String)get(param);
				if(value == null)
					continue;
			}
			list += param+"="+value+", "; //$NON-NLS-1$ //$NON-NLS-2$
		}
		if(list.length() > 1)
			list = list.substring(0, list.length()-2);
		list += ")"; //$NON-NLS-1$
		return list;
	}
}
