package com.ef_prime.rflow.node.base;

import com.ef_prime.rflow.Constants;
import com.ef_prime.rflow.RCommand;
import com.ef_prime.rflow.console.BasicCommand;
import com.ef_prime.rflow.console.Command;
import com.ef_prime.rflow.exception.IncompatibleCommandException;
import com.ef_prime.rflow.node.AbstractNodeModel;
import com.ef_prime.rflow.node.NodeModel;
import com.ef_prime.rflow.node.SentenceInfo;

public class FreeNodeModel extends AbstractNodeModel{

	private String command = ""; //$NON-NLS-1$
	
	public FreeNodeModel(){}
	
	public FreeNodeModel(String command){
		this.command = command;
	}
	
	private FreeNodeModel(FreeNodeModel model) {
		command = model.command;
	}

	public String getCommand() {
		if(!command.endsWith(Constants.NEWLINE_STR))
			return command + Constants.NEWLINE_STR;
		return command;
	}
	
	@Override
	public Command getCommandObject() {
		SentenceInfo[] infos = RCommand.parseToNodes(getCommand());
		if(infos == null){
			//TODO throw error ?
			return new BasicCommand(getCommand(), false);
		}
		
		BasicCommand[] commands = new BasicCommand[infos.length];
		for(int i = 0; i < commands.length; i++){
			commands[i] = new BasicCommand(infos[i].getLine(), false);
		}
			
		return new BasicCommand(commands);
	}
	
	@Override
	public void setCommand(String command) throws IncompatibleCommandException {
		this.command = command;
	}
	
	@Override
	public String getDefaultTitle() {
		String omitted = command.replaceAll("\n", " "); //$NON-NLS-1$ //$NON-NLS-2$
		if(omitted.length() > 10)
			omitted = omitted.substring(0, 10)+"..."; //$NON-NLS-1$
		return omitted;
		//return "FREE";
	}
	
	public NodeModel copy(){
		return new FreeNodeModel(this);
	}

	@Override
	public int hashCode() {
		return super.hashCode();
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof FreeNodeModel) {
			return super.equals(obj);
		}
		return false;
	}
}
