package com.ef_prime.rflow.node.base;

import java.util.Properties;

import com.ef_prime.rflow.exception.ModelCreationFailedException;
import com.ef_prime.rflow.flow.ViewLayout;
import com.ef_prime.rflow.node.NodeModel;

public class FunctionNodeModelController extends SubflowNodeModelController{

	@Override
	public Class<? extends NodeModel> getModelClass() {
		return FunctionNodeModel.class;
	}
	
	@Override
	public Properties getOptionProperties(NodeModel model) {
		FunctionNodeModel functionModel = (FunctionNodeModel)model;
		Properties p = new Properties();
		p.setProperty("function", functionModel.function); //$NON-NLS-1$
		p.setProperty("args", functionModel.args); //$NON-NLS-1$
		return p;
	}
	
	@Override
	public NodeModel createModel(Properties properties, String command, ViewLayout[] subflows) throws ModelCreationFailedException {
		if(subflows.length < 1)
			throw new ModelCreationFailedException();
		
		String function = properties.getProperty("function"); //$NON-NLS-1$
		String args = properties.getProperty("args"); //$NON-NLS-1$
		if(function == null || args == null)
			throw new ModelCreationFailedException();
		
		FunctionNodeModel model = new FunctionNodeModel(function, args, subflows[0]);
		
		return model;
	}
}
