package com.ef_prime.rflow.node.base;

import java.util.ArrayList;
import java.util.Properties;

import com.ef_prime.rflow.exception.ModelCreationFailedException;
import com.ef_prime.rflow.flow.ViewLayout;
import com.ef_prime.rflow.node.NodeModel;

public class IfNodeModelController extends SubflowNodeModelController{

	
	@Override
	public Class<? extends NodeModel> getModelClass() {
		return IfNodeModel.class;
	}
	
	@Override
	public Properties getOptionProperties(NodeModel model) {
		IfNodeModel ifModel = (IfNodeModel)model;

		Properties p = new Properties();
		
		for(int i = 0; i < ifModel.conditions.size(); i++){
			String c = ifModel.conditions.get(i);
			String key = "condition"; //$NON-NLS-1$
			if(i != 0)
				key = key + i;
			p.setProperty(key, c);
		}
		
		return p;
	}
	
	@Override
	public NodeModel createModel(Properties properties, String command, ViewLayout[] subflows) throws ModelCreationFailedException {
		if(subflows.length < 2)
			throw new ModelCreationFailedException();
		
		String key = "condition"; //$NON-NLS-1$
		String condition = properties.getProperty(key);
		//need at least one condition
		if(condition == null)
			throw new ModelCreationFailedException();
		
		
		ArrayList<String> conditions = new ArrayList<String>();
		conditions.add(condition);
		
		int i = 1;
		while(true){
			String c = properties.getProperty(key + i);
			if(c == null)
				break;
			else
			{
				conditions.add(c);
				i++;
			}
		}
		
		IfNodeModel model = new IfNodeModel(conditions, subflows);
		
		return model;
	}
}
