package com.ef_prime.rflow.node.base;

import java.util.Properties;

import com.ef_prime.rflow.exception.ModelCreationFailedException;
import com.ef_prime.rflow.flow.ViewLayout;
import com.ef_prime.rflow.node.NodeModel;

public class LoopNodeModelController extends SubflowNodeModelController{

	@Override
	public Class<? extends NodeModel> getModelClass() {
		return LoopNodeModel.class;
	}
	
	@Override
	public Properties getOptionProperties(NodeModel model) {
		LoopNodeModel loopModel = (LoopNodeModel)model;
		Properties p = new Properties();
		p.setProperty("loop", loopModel.getLoopType().getCode()); //$NON-NLS-1$
		if(loopModel.getLoopType().isCondition())
			p.setProperty("condition", loopModel.getCondition()); //$NON-NLS-1$
		return p;
	}
	
	@Override
	public NodeModel createModel(Properties properties, String command, ViewLayout[] subflows) throws ModelCreationFailedException {
		if(subflows.length < 1)
			throw new ModelCreationFailedException();
		LoopType type = LoopType.toLoopType(properties.getProperty("loop")); //$NON-NLS-1$
		String condition = properties.getProperty("condition"); //$NON-NLS-1$
		
		if(type == null || (type.isCondition() && condition == null)) 
			throw new ModelCreationFailedException();
		
		LoopNodeModel model = new LoopNodeModel(type, condition, subflows[0]);
		
		return model;
	}
}
