package com.ef_prime.rflow.node.base;

import java.awt.AlphaComposite;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;

import com.ef_prime.rflow.FileResource;
import com.ef_prime.rflow.flow.FlowViewer;

public class SubflowFrame extends JInternalFrame{
	
	private FlowViewer[] viewer;

	private boolean isTrans;
	private static final Color TRANS = new Color(255,255,255,0);
	//private static final Color TRANS_WHITE = new Color(255,255,255,100);
	private static final Icon icon = new ImageIcon(FileResource.BOX.getImage().getScaledInstance(16, 16, Image.SCALE_SMOOTH));
	
	public SubflowFrame(final FlowViewer[] viewer, JComponent component)
	{
		super("", true, true, true, true); //$NON-NLS-1$
		this.viewer = viewer;
		
		//setUI(new BasicInternalFrameUI(this));

		JPanel trans = new JPanel(new BorderLayout());
		trans.setBackground(TRANS);
		trans.setOpaque(false);
		
		setContentPane(trans);
		getContentPane().add(component);
		setDefaultCloseOperation(JInternalFrame.HIDE_ON_CLOSE);
		setOpaque(false);
		setFrameIcon(icon);
		/*addMouseListener(new MouseAdapter(){
			@Override
			public void mousePressed(MouseEvent e) {
				System.out.println(getContentPane().getBounds().contains(e.getPoint()));
			}
		});*/
		/*
		viewer.addMouseListener(new MouseAdapter(){
			@Override
			public void mousePressed(MouseEvent e) {
				//System.out.println(e.getPoint());
				//System.out.println(getContentPane().getLocation());
				isTrans = false;
				viewer.setBackground(Color.WHITE);
				repaint();
			}
		});
		addComponentListener(new ComponentAdapter(){
			@Override
			public void componentMoved(ComponentEvent e) {
				isTrans = true;
				viewer.setBackground(TRANS_WHITE);
			}
		});*/
		
		
		pack();
	}
	
	public FlowViewer[] getViewer() {
		return viewer;
	}
	
	public FlowViewer getActiveViewer(){
		SubflowNodeModel model = (SubflowNodeModel)viewer[0].getGraph().getParentNode().getModel();
		return model.getActiveViewer();
	}
	
	Dimension size = null;
	
	public void bar(){
		/*if(size == null){
			size = getContentPane().getSize();
			setSize(getSize().width, getSize().height-size.height);
		}*/
		
		//viewer.setBackground(TRANS_WHITE);
		isTrans = true;
		repaint();
	}
	
	public void unbar(){
		/*if(size != null){
			setSize(getSize().width, getSize().height+size.height);
			size = null;
		}*/
		
		//viewer.setBackground(Color.WHITE);
		isTrans = false;
		repaint();
	}
	
	
	@Override
	public void paint(Graphics g) {
		
		if(isTrans)
			((Graphics2D)g).setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_ATOP, 0.4f));
		else
			((Graphics2D)g).setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_ATOP, 1.0f));
		
		super.paint(g);
	}
}
