package com.ef_prime.rflow.node.base;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.Ellipse2D;
import java.awt.image.BufferedImage;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import com.ef_prime.rflow.flow.rendering.NodeRendering;
import com.ef_prime.rflow.flow.rendering.NodeShape;
import com.ef_prime.rflow.node.AbstractNodeModel;
import com.ef_prime.rflow.node.NodeModel;

public class TunnelNodeModel extends AbstractNodeModel{
	
//	private static final Shape ellipseShape = 
//		new Ellipse2D.Double(-NodeShape.DEFAULT_SIZE/4,-NodeShape.DEFAULT_SIZE/2,
//				NodeShape.DEFAULT_SIZE/2,NodeShape.DEFAULT_SIZE);
	
	private static final int size = 14;
	private static final Shape circleShape = new Ellipse2D.Double(-size/2,-size/2,size,size);
	private static final Icon icon;
	
	private int type;
	private static final int IN = 0;
	private static final int OUT = 1;
	
	public static final TunnelNodeModel inModel = new TunnelNodeModel(IN);
	public static final TunnelNodeModel outModel = new TunnelNodeModel(OUT);
	
	static{

		Shape s = NodeShape.CIRCLE.getShape();
		Rectangle rect = s.getBounds();
		int offset = 2;
		BufferedImage image = new BufferedImage(rect.width+offset*2, rect.height+offset*2, BufferedImage.TYPE_INT_ARGB);
		Graphics2D g = (Graphics2D)image.getGraphics();
		s = AffineTransform.getTranslateInstance(-rect.x+offset, -rect.y+offset).createTransformedShape(s);
		g.setPaint(NodeRendering.FILLPAINT);
		//g.setStroke(NodeRendering.BOLDSTROKE);
		g.setStroke(new BasicStroke(3.2f));
		g.draw(s);

		//icon = new ImageIcon(image);
		icon = new ImageIcon(image.getScaledInstance(16, 16, Image.SCALE_SMOOTH));
		image.flush();
	}
	
	private TunnelNodeModel(int type){
		this.type = type;
	}
	
	/*	
	public static TunnelNodeModel getInTunnelModel(){
		if(inModel == null)
			inModel = new TunnelNodeModel(IN);
		return inModel;
	}
	
	public static TunnelNodeModel getOutTunnelModel(){
		if(outModel == null)
			outModel = new TunnelNodeModel(OUT);
		return outModel;
	}*/
	
	
	/*@Override
	public void showConfigDialog(Window parent) throws CanceledException {
		throw new CanceledException();
	}*/

	public String getCommand() {
		return ""; //$NON-NLS-1$
	}
	

	@Override
	public String getDefaultTitle() {
		switch(type){
		case IN:return "in";
		case OUT:return "out";
		default:return null;
		}
	}
	
	@Override
	public Shape getShape() {
		return circleShape;
	}
	
	@Override
	public Icon getSmallIcon() {
		return icon;
	}
	
	public boolean isInModel(){
		return type == IN;
	}
	
	public boolean isOutModel(){
		return type == OUT;
	}
	
	@Override
	public boolean hasCommand() {
		return false;
	}

	public NodeModel copy() {
		return this;
	}
	
	@Override
	public int hashCode() {
		return super.hashCode();
	}
	
	@Override
	public boolean equals(Object obj) {
		return this == obj && super.equals(obj);
	}
}
