package com.ef_prime.rflow.node.base;

import java.util.Properties;

import com.ef_prime.rflow.exception.ModelCreationFailedException;
import com.ef_prime.rflow.flow.ViewLayout;
import com.ef_prime.rflow.node.NodeModel;
import com.ef_prime.rflow.node.ShortNodeModelController;

public class TunnelNodeModelController extends ShortNodeModelController{
	/*@Override
	protected Document createXMLDocument(NodeModel model, DOMImplementation domImpl) {
		return null;
	}*/
	
	public Class<? extends NodeModel> getModelClass() {
		return TunnelNodeModel.class;
	}
	
	private static final String KEY_IO = "io"; //$NON-NLS-1$
	private static final String IO_IN = "in"; //$NON-NLS-1$
	private static final String IO_OUT = "out"; //$NON-NLS-1$
	
	public Properties getOptionProperties(NodeModel model) {
		Properties properties = new Properties();
		properties.setProperty(KEY_IO, 
				(model == TunnelNodeModel.inModel)?IO_IN:IO_OUT);
		return properties;
	}
	
	public NodeModel createModel(Properties properties, String command, ViewLayout[] subflows) throws ModelCreationFailedException {
		String io = properties.getProperty(KEY_IO);
		if(io.equals(IO_IN))
			return TunnelNodeModel.inModel;
		else
			return TunnelNodeModel.outModel;
	}
	
	@Override
	public boolean isAddable() {
		return false;
	}
}
