package com.ef_prime.rflow.node.pack;

import java.awt.Dimension;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.ef_prime.rflow.FileResource;
import com.ef_prime.rflow.exception.InvalidOptionException;

public abstract class ArgComponent extends JPanel{
	
	private String param;
	
	private boolean isOperative;
	private static final Icon icon = FileResource.ERROR;
	private JLabel operativeLabel;
	
	private Vector<ArgComponent> list;
	
	
	public ArgComponent(String param){
		this.param = param;
	}
	
	public String getParameter(){
		return param;
	}
	
	public boolean hasChild(){
		return list != null && list.size() > 0;
	}
	
	public Iterator<ArgComponent> children(){
		if(!hasChild())
			return null;
		return list.iterator();
	}
	
	public void addArgumentComponent(ArgComponent ac){
		if(list == null)
			list = new Vector<ArgComponent>(2);
		list.add(ac);
	}
	
	public abstract String getValue() throws InvalidOptionException;
	
	public void setValue(String value){
		setOperative(value.equals("") || isValidValue(value)); //$NON-NLS-1$
		if(isOperative()){
			setValueToComponent(value);
		}
	}
	public abstract void setValueToComponent(String value);
	
	protected boolean isValidValue(String value){
		return true;
	}
	
	public boolean isOperative() {
		return isOperative;
	}
	
	public void setOperative(boolean isOperative) {
		this.isOperative = isOperative;
		//getOperativeLabel().setVisible(!isOperative);
		getOperativeLabel().setIcon((isOperative)?null:icon);
	}
	
	public JLabel getOperativeLabel() {
		if(operativeLabel == null){
			operativeLabel = new JLabel();
			operativeLabel.setToolTipText("ＧＵＩで表現できない値が設定されています。");
			operativeLabel.setPreferredSize(new Dimension(16 ,16));
			operativeLabel.setMaximumSize(new Dimension(16 ,16));
			//operativeLabel.setBackground(Color.GRAY);
			//operativeLabel.setOpaque(true);
		}
		return operativeLabel;
	}
	
	public JPanel getComponentPanel(){
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		panel.add(getOperativeLabel());
		panel.add(this);
		//panel.add(Box.createHorizontalStrut(20));
		return panel;
	}
	
	public static ArgComponent createNoParamArgumentComponent(){
		return new ArgComponent(null){
			@Override
			public String getValue() throws InvalidOptionException {
				return null;
			}
			@Override
			public void setValueToComponent(String value) {
			}
		};
	}
}
