package com.ef_prime.rflow.node.pack;

import java.awt.Dimension;
import java.util.ArrayList;
import java.util.List;

import com.ef_prime.rflow.node.pack.DefaultArgComponents.ACCheckBox;
import com.ef_prime.rflow.node.pack.DefaultArgComponents.ACFileInput;
import com.ef_prime.rflow.node.pack.DefaultArgComponents.ACRadioButtons;

public class UIPackFactory {
	
	public static UIPack[] getPacks(){
		return new UIPack[]{
				createReadTable(),
				createLm()
		};
	}
	
	public static UIPack createReadTable(){
		UIPackData data = new UIPackData("read.table", "ファイル入力");
		
		UIPackPanelBuilder builder = new UIPackPanelBuilder(){
			@Override
			protected ArgComponent[] getArgComponents() {
				ACFileInput file = DefaultArgComponents.createFileInput("file", "ファイル", true);
				
				ACRadioButtons sep = DefaultArgComponents.createRadioButton("sep", "区切り文字", 
						new String[]{"タブ","カンマ","スペース","その他"}, 
						new String[]{"\"\\t\"", "\",\"", "\" \"", null}, true, true);
				ACCheckBox checkBox = DefaultArgComponents.createCheckBox("header", "1行目を変数名として読み込む");
				
				file.setPreferredSize(new Dimension(350, 20));
				sep.setPreferredSize(new Dimension(300, 60));
				sep.setMaximumSize(new Dimension(300, 60));
				
				ArgComponent[] ac = new ArgComponent[]{DefaultArgComponents.createSymbolInput("データフレーム名"), 
						file, sep, checkBox};
				return ac;
			}

			@Override
			protected int getAssignCompIndex() {
				return 0;
			}

			@Override
			protected int[] getPanelIndices() {
				return new int[]{0};
			}
			
			@Override
			protected String[] getPanelTitles() {
				return new String[]{""};
			}
		};
		
		return new UIPack(data, builder);
	}
	
	public static UIPack createLm(){
		UIPackData data = new UIPackData("lm", "線形回帰");


		UIPackPanelBuilder builder = new UIPackPanelBuilder(){
			@Override
			protected ArgComponent[] getArgComponents() {
				List<ArgComponent> list = new ArrayList<ArgComponent>();
				list.add(DefaultArgComponents.createSymbolInput("結果の代入先"));
				list.add(DefaultArgComponents.createSimpleFormulaEditor(
					"formula", "data",
					"式", "Y", "X"));
				return list.toArray(new ArgComponent[0]);
			}

			@Override
			protected int getAssignCompIndex() {
				return 0;
			}

			@Override
			protected int[] getPanelIndices() {
				return new int[]{0};
			}
			
			@Override
			protected String[] getPanelTitles() {
				return new String[]{""};
			}
		};
		
		return new UIPack(data, builder);
	}
}
