package com.ef_prime.rflow.resource;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import java.util.Enumeration;
import java.util.Locale;
import java.util.ResourceBundle;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Task;

public class MakeXMLResourcesAntTask extends Task {

	private String name = ""; //$NON-NLS-1$
	
	@Override
	public void execute() throws BuildException {
        Locale.setDefault(Locale.ENGLISH);
        Locale[] ary = Messages.getLocales();
        
        for(Locale locale : ary)
        {
			PrintStream out;
			try {
				File parent = new File(name);
				File file;
				if(parent.exists())
					file = new File(parent,"resource." + locale.getLanguage()); //$NON-NLS-1$
				else
					file = new File("resource." + locale.getLanguage()); //$NON-NLS-1$
				
				out = new PrintStream(file,"UTF-8"); //$NON-NLS-1$
		        ResourceBundle bundle = ResourceBundle.getBundle(
						"com.ef_prime.rflow.resource.messages",locale); //$NON-NLS-1$
		
			     for (Enumeration<String> e = bundle.getKeys() ; e.hasMoreElements() ;) {
			    	 String key = e.nextElement();
			         String value = bundle.getString(key);
			         value = value.replace("\r", ""); //$NON-NLS-1$ //$NON-NLS-2$
			         value = value.replace("\n", ""); //$NON-NLS-1$ //$NON-NLS-2$
			         value = value.replace("&", "&amp;"); //$NON-NLS-1$ //$NON-NLS-2$
			         value = value.replace("'", "&apos;"); //$NON-NLS-1$ //$NON-NLS-2$
			         value = value.replace("\"", "&quot;"); //$NON-NLS-1$ //$NON-NLS-2$
			         value = value.replace("<", "&lt;"); //$NON-NLS-1$ //$NON-NLS-2$
			         value = value.replace(">", "&gt;"); //$NON-NLS-1$ //$NON-NLS-2$
			         
					out.println("<!ENTITY " + key + " \"" + value + "\">"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			     }
			} catch (FileNotFoundException e1) {
				throw new BuildException(e1);
			} catch (UnsupportedEncodingException e1) {
				throw new BuildException(e1);
			}			     
        }
	}
	
	public void setFile(String name)
	{
		this.name = name;
	}
	
}
