package com.ef_prime.rflow.resource;

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class Messages {
	private static final String BUNDLE_NAME = "com.ef_prime.rflow.resource.messages"; //$NON-NLS-1$

	private static ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME, Locale.getDefault());

	private Messages() {
	}
	
	public static void prepareResourceBundle(){
		if(!RESOURCE_BUNDLE.getLocale().equals(Locale.getDefault()))
				RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME, Locale.getDefault());
	}

	public static String getString(String key) {
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}

	public static Locale[] getLocales(){
		return new Locale[]{Locale.ENGLISH, Locale.JAPANESE};
	}
	
	/**
	 * jarにして使用したときに動作しないことが確認されました。
	 * @return
	 */
	/*
	@Deprecated
	public static Locale[] getLocales(){
		int index = BUNDLE_NAME.lastIndexOf('.');
		String filePath = BUNDLE_NAME.substring(0, index);
		String resourceName = BUNDLE_NAME.substring(index+1, BUNDLE_NAME.length());
		filePath = filePath.replace('.', '/');
		List<Locale> locales = new ArrayList<Locale>();
		URL url = ClassLoader.getSystemResource(filePath);
		File file;
		try {
			file = new File(url.toURI());
		} catch (URISyntaxException e) {
			e.printStackTrace();return new Locale[0];
		}
		for(File f : file.listFiles()){
			String name = f.getName();
			if(name.startsWith(resourceName) && name.endsWith(".properties")){ //$NON-NLS-1$
				String suffix = name.substring(resourceName.length(), name.length()-".properties".length()); //$NON-NLS-1$
				
				if(suffix.length() < 1)continue;
				String lang = suffix.substring(1, suffix.length());//assume "_en" -> "en"
				locales.add(new Locale(lang));
			}
		}
		return locales.toArray(new Locale[0]);
	}*/
}
