package com.ef_prime.rflow.tool;

import java.awt.BorderLayout;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

import com.ef_prime.rflow.FileResource;
import com.ef_prime.rflow.Version;
import com.ef_prime.rflow.resource.Messages;

public class AboutDialog extends JDialog{

	public AboutDialog(Dialog owner) throws HeadlessException {
		super(owner);
		init();
	}

	public AboutDialog(Frame owner) throws HeadlessException {
		super(owner);
		init();
	}
	
	private void init(){
		setTitle(Messages.getString("Action.about")); //$NON-NLS-1$
		setResizable(false);
		//setUndecorated(true);
		
		//スプラッシュ画像
		JLabel label = new JLabel(FileResource.SPLASH, JLabel.CENTER);
		JPanel labelPanel = new JPanel(new BorderLayout());
		labelPanel.add(label);
		//バージョン表示
		JLabel version = new JLabel("<html><b>R AnalyticFlow version "+Version.VERSION+"</b><br><br>" + //$NON-NLS-1$ //$NON-NLS-2$
				"Copyright (c) 2007-2008, Ef-prime, Inc. and other licensors. All rights reserved.<br>" + //$NON-NLS-1$
				"R AnalyticFlow and the R AnalyticFlow logos are trademarks of Ef-prime, Inc.<br>" + //$NON-NLS-1$
				"See license.txt for detailed conditions about the programs and other trademarks.</html>", JLabel.LEFT); //$NON-NLS-1$
		version.setBorder(new EmptyBorder(10,15,0,0));
		JPanel versionPanel = new JPanel(new BorderLayout());
		versionPanel.add(version);
		//ボタン
		JButton ok = new JButton(Messages.getString("Button.ok")); //$NON-NLS-1$
		ok.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				AboutDialog.this.dispose();
			}
		});
		ok.setMaximumSize(new Dimension(100, 22));
		ok.setPreferredSize(new Dimension(100, 22));
		Box buttonBox = Box.createHorizontalBox();
		buttonBox.setBorder(new EmptyBorder(10,10,10,10));
		buttonBox.add(Box.createHorizontalGlue());
		buttonBox.add(ok);
		buttonBox.add(Box.createHorizontalGlue());

		Box box = Box.createVerticalBox();
		box.add(labelPanel);
		box.add(Box.createVerticalStrut(5));
		box.add(versionPanel);
		box.add(Box.createVerticalStrut(5));
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(box, BorderLayout.CENTER);
		getContentPane().add(buttonBox, BorderLayout.SOUTH);
		
		pack();
	}
}
