package com.ef_prime.rflow.tool;

import java.awt.Dimension;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;

import com.ef_prime.rflow.Prefs;
import com.ef_prime.rflow.resource.Messages;

public class ButtonPanel extends JPanel{
	
	private JButton[] buttons;
	
	public ButtonPanel(ActionListener okAction, 
			ActionListener cancelAction)
	{
		this(okAction, cancelAction, Prefs.BUTTON_SIZE);
	}

	public ButtonPanel(ActionListener okAction, 
			ActionListener cancelAction,
			Dimension buttonSize)
	{
		this(new ActionListener[]{okAction, cancelAction}, 
				new String[]{
				Messages.getString("Button.ok"),  //$NON-NLS-1$
				Messages.getString("Button.cancel")}, //$NON-NLS-1$
				buttonSize, 50);
	}
	
	
	public ButtonPanel(
			ActionListener[] listeners,
			String[] labels,
			Dimension buttonSize,
			int space)
	{
		super();
		if(listeners.length != labels.length)
			throw new RuntimeException("listeners.length != labels.length"); //$NON-NLS-1$
		
		setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
		
		buttons = new JButton[listeners.length];
		for(int i = 0; i < buttons.length; i++){
			JButton b = createButton(labels[i], buttonSize);
			b.addActionListener(listeners[i]);
			add(b);
			
			buttons[i] = b;
			if(i != buttons.length-1)
				add(Box.createHorizontalStrut(space));
		}
		
	}
	
	public JButton[] getButtons(){
		return buttons;
	}
	
	public JButton getFirstButton() {
		return buttons[0];
	}
	
	JButton createButton(String title, Dimension buttonSize){
		JButton button = new JButton(title);
		button.setPreferredSize(buttonSize);
		button.setMaximumSize(buttonSize);
		
		return button;
	}
}
