package com.ef_prime.rflow.tool;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.swing.Box;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;

import com.ef_prime.rflow.resource.Messages;

public class ErrorDialog extends JDialog{
	
	public static void show(Frame parent, String message, Throwable e){
		ErrorDialog dialog = new ErrorDialog(parent, message, e);
		dialog.setVisible(true);
		dialog.dispose();
	}
	
	private ErrorDialog(Frame parent, String message, Throwable e){
		super(parent, true);
		setTitle(Messages.getString("Error.title.error")); //$NON-NLS-1$
		
		//ラベル
		JLabel label = new  JLabel(message);
		Box labelBox = Box.createHorizontalBox();
		labelBox.add(label);
		labelBox.add(Box.createHorizontalGlue());
		
		//エラー詳細
		StringWriter sw = new StringWriter();
		PrintWriter writer = new PrintWriter(sw);
		e.printStackTrace(writer);
		writer.close();
		JTextArea area = new JTextArea();
		area.setText(sw.toString());
		area.setEditable(false);
		area.setPreferredSize(new Dimension(400, 100));
		area.setMaximumSize(area.getPreferredSize());
		
		Box box = Box.createVerticalBox();
		box.setBorder(new EmptyBorder(10,10,10,10));
		box.add(labelBox);
		box.add(Box.createVerticalStrut(10));
		box.add(new JScrollPane(area));
		
		
		//contentpane
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(box);
		
		pack();
		setLocationRelativeTo(parent);
	}
}
