package com.ef_prime.rflow.tool;

import java.awt.Graphics2D;
import java.util.LinkedList;

import javax.swing.text.AttributeSet;
import javax.swing.text.Element;
import javax.swing.text.StyleConstants;

import org.fife.ui.rsyntaxtextarea.DefaultToken;
import org.fife.ui.rsyntaxtextarea.SyntaxView;
import org.fife.ui.rsyntaxtextarea.Token;

public class RSyntaxView extends SyntaxView{

	public RSyntaxView(Element elem) {
		super(elem);
	}

	@Override
	public float drawLine(Token token, Graphics2D g, float x, float y) {
		//find composed text element
		//Element line = getElement().getElement(getElement().getElementIndex(token.offset));
		LinkedList<Element> elements = new LinkedList<Element>();
		//elements.add(line);
		elements.add(getElement());
		Element composed = null;
		while(elements.size() > 0){
			Element e = elements.pop();
			if(e.isLeaf()){
		        AttributeSet as = e.getAttributes();
		    	if((as != null) && (as.isDefined(StyleConstants.ComposedTextAttribute))){
		    		composed = e;
		    		break;//only one composed text element at one time
		    	}
			}else{
				for(int i = e.getElementCount()-1; i >= 0; i--){
					elements.addFirst(e.getElement(i));
				}
			}
		}
		
		if(composed != null){
			Token t = token;
			Token lastToken = null;
			while(t != null){
				if(t.containsPosition(composed.getStartOffset())){
					//next token
					Token next = t.getNextToken();
					int count = t.textCount;
					while(next != null && next.type != Token.NULL && 
							count < (composed.getEndOffset() - composed.getStartOffset())){
						count += next.textCount;
						next = next.getNextToken();
					}
					
					//break token into parts:
					//token1(orginal), token2(composed text), token3(original)
					//first
					Token first = new DefaultToken();
					first.copyFrom(t);
					first.textCount = composed.getStartOffset() - first.offset;
					//second
					Token second = new DefaultToken();
					second.copyFrom(t);
					second.offset = composed.getStartOffset();
					second.textOffset = first.textOffset + first.textCount;
					second.textCount = composed.getEndOffset() - composed.getStartOffset();
					second.type = Token.PREPROCESSOR;//use this type for composed text
					//third
					Token third = new DefaultToken();
					third.copyFrom(t);
					third.offset = second.offset + second.textCount;
					third.textOffset = second.textOffset + second.textCount;
					third.textCount = t.textCount - second.textCount - first.textCount;

					if(lastToken != null){
						lastToken.setNextToken((first.textCount == 0)?second:first);
					}else{
						token = (first.textCount == 0)?second:first;
					}
					first.setNextToken(second);
					second.setNextToken((third.textCount == 0)?next:third);
					third.setNextToken(next);
					
					break;
				}
				lastToken = t;
				t = t.getNextToken();
			}
		}
		return super.drawLine(token, g, x, y);
	}
	
}
