package com.ef_prime.rflow.tool;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.ActionMap;
import javax.swing.Box;
import javax.swing.InputMap;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;

public class RflowOptionPane extends JOptionPane{
	
	/**
	 * show YEW/NO/CANCEL option dialog with y/n/c shortcut
	 * @param parentComponent
	 * @param message
	 * @param title
	 * @param messageType
	 * @return
	 */
	public static int showConfirmDialog(Component parentComponent, String message, String title, int messageType){
		final JOptionPane pane = new JOptionPane(message, messageType, JOptionPane.YES_NO_CANCEL_OPTION);
		final JDialog dialog = pane.createDialog(parentComponent, title);
		
		ActionMap map = SwingUtilities.getUIActionMap(pane);
		map.put("yes", new AbstractAction(){  //$NON-NLS-1$
			public void actionPerformed(ActionEvent e) {
				pane.setValue(YES_OPTION);
				dialog.dispose();
			}
		});
		map.put("no", new AbstractAction(){  //$NON-NLS-1$
			public void actionPerformed(ActionEvent e) {
				pane.setValue(NO_OPTION);
				dialog.dispose();
			}
		});
		map.put("cancel", new AbstractAction(){  //$NON-NLS-1$
			public void actionPerformed(ActionEvent e) {
				pane.setValue(CANCEL_OPTION);
				dialog.dispose();
			}
		});
		InputMap inputMap = SwingUtilities.getUIInputMap(pane, JComponent.WHEN_IN_FOCUSED_WINDOW);
		inputMap.put(KeyStroke.getKeyStroke('y'), "yes");  //$NON-NLS-1$
		inputMap.put(KeyStroke.getKeyStroke('n'), "no");  //$NON-NLS-1$
		inputMap.put(KeyStroke.getKeyStroke('c'), "cancel");  //$NON-NLS-1$
		
		
		dialog.setVisible(true);
		dialog.dispose();

        Object selectedValue = pane.getValue();
        if(selectedValue == null)
        	return CLOSED_OPTION;
        if(selectedValue instanceof Integer)
        	return ((Integer)selectedValue).intValue();
        return CLOSED_OPTION;
		
	}
	
	public static int showTextAreaDialog(Component parentComponent, String title, String message, String textAreaMessage
			, int messageType, int optionType)
	{
		JScrollPane sp = new JScrollPane(new JTextArea(textAreaMessage));
		sp.setPreferredSize(new Dimension(300, 150));
		JOptionPane opPane = new JOptionPane(message, JOptionPane.ERROR_MESSAGE, JOptionPane.DEFAULT_OPTION);
		opPane.add(Box.createVerticalStrut(10), opPane.getComponentCount()-1);
		opPane.add(sp, opPane.getComponentCount()-1);
		JDialog dialog = opPane.createDialog(parentComponent, title);
		dialog.setVisible(true);
		dialog.dispose();

        Object selectedValue = opPane.getValue();
        if(selectedValue == null)
        	return CLOSED_OPTION;
        if(selectedValue instanceof Integer)
        	return ((Integer)selectedValue).intValue();
        return CLOSED_OPTION;
	}
}
