package com.ef_prime.rflow.tool;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import com.ef_prime.rflow.Constants;
import com.ef_prime.rflow.resource.Messages;

public class SimplePager extends JFrame{
	
	private boolean removeHelpUnknown = true;
	//TODO 正式な仕様の確認
	private static final String HELP_UNKNOWN = "_\b"; //$NON-NLS-1$
	
	public SimplePager(String file, String header, String title, boolean deleteFile){
		super(title);
		File f = new File(file);
		JTextArea textArea = new JTextArea();
		textArea.setEditable(false);
		getContentPane().add(new JScrollPane(textArea));

		boolean success = true;
		try {
			BufferedReader r = new BufferedReader(new FileReader(f));
			while (r.ready()) {
				String line = r.readLine();
				if(removeHelpUnknown){
					line = line.replaceAll(HELP_UNKNOWN, ""); //$NON-NLS-1$
				}
				textArea.append(line);
				textArea.append(Constants.NEWLINE_STR);
			}
			r.close();
			r = null;
		} catch (IOException e) {
			success = false;
		}
		
		setSize(600, 400);
		setVisible(true);

		if (deleteFile){
			if(!f.delete())
				JOptionPane.showMessageDialog(this, Messages.getString("Error.file.delete") + ":" + file, //$NON-NLS-1$ //$NON-NLS-2$
						Messages.getString("Error.title.error"), JOptionPane.ERROR_MESSAGE); //$NON-NLS-1$
		}
		
		if(!success){
			JOptionPane.showMessageDialog(this, Messages.getString("Error.on_reading"), Messages.getString("Error.title.error"), JOptionPane.ERROR_MESSAGE); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}
}
