package com.ef_prime.rflow.tool;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.AbstractListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.Popup;
import javax.swing.PopupFactory;

public class SupportPopup {

	
	private Popup popup;
	private JList list;
	private JScrollPane scrollPane;
	
	public SupportPopup(Component owner, int x, int y, Dimension size){
		list = new JList();
		scrollPane = new JScrollPane(list); 
		scrollPane.setPreferredSize(size);
		/*if(GraphicsEnvironment.getLocalGraphicsEnvironment().getScreenDevices().length == 1){
			Rectangle rect = GraphicsEnvironment.getLocalGraphicsEnvironment().getScreenDevices()[0].getDefaultConfiguration().getBounds();
			if(rect.height < y + size.height){
				y = rect.height - size.height;
				
			}
		}*/
		popup = PopupFactory.getSharedInstance().getPopup(owner, scrollPane, x, y);
		//list.clearSelection();
	}
	
	JList getList(){
		return list;
	}
	
	public void setListModel(String[] supportList){
		list.setModel(new SimpleListModel(supportList));
		//list.setSelectedIndex(0);
	}
	
	public void selectPrevious(){
		int select = list.getSelectedIndex() -1;
		if(select > -1){
			list.setSelectedIndex(select);
			list.ensureIndexIsVisible(select);
		}
	}

	public boolean isSelectionEmpty() {
		return list.isSelectionEmpty();
	}
	
	public String getSelected(){
		return list.getSelectedValue().toString();
	}
	
	public void selectNext(){
		int select = list.getSelectedIndex() + 1;
		if(select < list.getModel().getSize()){
			list.setSelectedIndex(select);
			list.ensureIndexIsVisible(select);
		}
	}

	public void hide() {
		popup.hide();
	}

	public void show() {
		popup.show();
	}
	
	private static class SimpleListModel extends AbstractListModel{

		private String[] elements;
		
		SimpleListModel(String[] elements){
			this.elements = elements;
		}
		
		public Object getElementAt(int index) {
			return elements[index];
		}

		public int getSize() {
			return elements.length;
		}
		
	}
}
