package com.ef_prime.rflow.tool;

import javax.swing.text.JTextComponent;

import com.ef_prime.rflow.RCommand;
import com.ef_prime.rflow.util.RObjFilter;

public class SupportedInputFactory {
	
	public static SupportControl setFunctionSupport(JTextComponent tc){
		SupportControl supportControl = new SupportControl(tc){
			@Override
			protected String[] getSupportWords(String input, int index) {
				switch(index){
				case 1: return RCommand.supportListGlobal(input);
				default: return RCommand.supportList(input);
				}
			}
		};
		return supportControl;
	}
	

	public static SupportControl setFunctionSupport(JTextComponent tc, final RObjFilter filter){
		SupportControl supportControl = new SupportControl(tc){
			@Override
			protected String[] getSupportWords(String input, int index) {
				return RCommand.getObjectsFiltered(filter.getFilterFunction());
			}
		};
		return supportControl;
	}
}
