package com.ef_prime.rflow.tool;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.undo.UndoManager;

public class TextGetter{
	
	private String name;
	private JDialog dialog;
	
	private TextGetter(Window parent, String title, String label, String orginalName){
		if(parent instanceof Dialog)
			dialog = new JDialog((Dialog)parent, title, true);
		else
			dialog = new JDialog((Frame)parent, title, true);
		dialog.setTitle(title);
		
		
		if(orginalName == null)
			orginalName = ""; //$NON-NLS-1$
		
		//名前入力
		JLabel nameLabel = new JLabel(label);
		final UndoManager undoManager = new UndoManager();
		final JTextField nameField = new RflowTextField(orginalName);
		nameField.selectAll();
		nameField.getDocument().addUndoableEditListener(undoManager);
		Box nameBox = Box.createHorizontalBox();
		nameBox.setPreferredSize(new Dimension(200, 20));
		nameBox.add(nameLabel);
		nameBox.add(Box.createHorizontalStrut(5));
		nameBox.add(nameField);
		
		//ボタン
		ActionListener ok = new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				name = nameField.getText();
				dialog.dispose();
			}
		}; 
		ActionListener cancel = new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				name = null;
				dialog.dispose();
			}
		};
		final ButtonPanel buttonPanel = new ButtonPanel(ok, cancel);
		
		//キー
		nameField.addKeyListener(new KeyAdapter(){
			@Override
			public void keyPressed(KeyEvent e) {
				if(e.getModifiers() == KeyEvent.CTRL_MASK){
					switch(e.getKeyCode()){
					case KeyEvent.VK_Z:
						if(undoManager.canUndo())
							undoManager.undo();
						break;
					case KeyEvent.VK_Y:
						if(undoManager.canRedo())
							undoManager.redo();
						break;
					}
				}else{
					switch(e.getKeyCode()){
					case KeyEvent.VK_ENTER:
						buttonPanel.getFirstButton().requestFocus();
						break;
					}
				}
			}
		});

		//パネル
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		int sp = 10;
		panel.setBorder(new EmptyBorder(sp, sp, sp, sp));
		
		panel.add(nameBox);
		panel.add(Box.createVerticalStrut(10));
		panel.add(buttonPanel);
		
		dialog.getContentPane().add(panel);
		dialog.pack();
		dialog.setLocationRelativeTo(parent);
	}
	
	public static String getText(Window parent, String title, String label, String orginalName){
		TextGetter getter = new TextGetter(parent, title, label, orginalName);
		getter.dialog.setVisible(true);
		getter.dialog.dispose();
		return getter.name;
	}
}
