package com.ef_prime.rflow.util;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;

public class BackgroundLayout implements LayoutManager{

	private Component[] c;
	
	public BackgroundLayout(Component background){
		c = new Component[]{background};
	}
	
	public BackgroundLayout(Component[] backgrounds){
		c = backgrounds;
	}

	public void addLayoutComponent(String name, Component comp) {
	}

	public void layoutContainer(Container parent) {
		Insets insets = parent.getInsets();
		int top = insets.top;
		int bottom = parent.getHeight() - insets.bottom;
		int left = insets.left;
		int right = parent.getWidth() - insets.right;
		for(Component co : c)
			co.setBounds(left, top, right - left, bottom - top);
	}

	public Dimension minimumLayoutSize(Container parent) {
		return c[0].getMinimumSize();
	}

	public Dimension preferredLayoutSize(Container parent) {
		return c[0].getPreferredSize();
	}

	public void removeLayoutComponent(Component comp) {
	}
}
