package com.ef_prime.rflow.util;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

/**
 * アイコンを色づけします
 * @author nagai
 *
 */
@SuppressWarnings("serial") //$NON-NLS-1$
public class ColorMaskedIcon extends ImageIcon{
	
	int width;
	int height;

	public ColorMaskedIcon(Icon icon, Color color, float alpha){
		this.width = icon.getIconWidth();
		this.height = icon.getIconHeight();
		createMask(icon, color, alpha);
	}
	
    private void createMask(Icon icon, Color color, float alpha){
    	BufferedImage maskedImage = new BufferedImage(getIconWidth(), getIconHeight(), BufferedImage.TYPE_INT_ARGB);
        Graphics2D g2d = (Graphics2D)maskedImage.getGraphics();
        icon.paintIcon(new JLabel(), g2d, 0, 0);
        //g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_IN, alpha));
        g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_ATOP, alpha));
        g2d.setColor(color);
        g2d.fillRect(0, 0, maskedImage.getWidth(), maskedImage.getHeight());
        
        setImage(maskedImage);
    }
	
    
    /*-----------------------------icon interface--------------------------------*/
	public int getIconHeight() {
		return height;
	}

	public int getIconWidth() {
		return width;
	}

	public void paintIcon(Component c, Graphics g, int x, int y) {
		 g.drawImage(getImage(), x, y, c);
	}

}
