package com.ef_prime.rflow.util;

import java.awt.Component;
import java.io.File;

import javax.swing.JOptionPane;

import com.ef_prime.rflow.resource.Messages;

public class ConfirmOverwrite {
	
	/**
	 * 上書き保存がキャンセルされた場合のみfalseを返します。
	 * @param file
	 * @param parent
	 * @return
	 */
	public static boolean confirm(String file, Component parent){
		return confirm(new File(file), parent);
	}

	/**
	 * 上書き保存がキャンセルされた場合のみfalseを返します。
	 * @param file
	 * @param parent
	 * @return
	 */
	public static boolean confirm(File file, Component parent){
		if(file.exists()){
			int ret = JOptionPane.showConfirmDialog(
					parent, 
					file.getAbsolutePath()+" "+Messages.getString("ConfirmOverwrite.cofirm_overwrite"), //$NON-NLS-1$ //$NON-NLS-2$
					Messages.getString("ConfirmOverwrite.overwrite"), //$NON-NLS-1$
					JOptionPane.YES_NO_OPTION);
			if(ret == JOptionPane.NO_OPTION)return false;
		}
		return true;
	}
	
	public static final int FILE_NOT_FOUND = -1;
	public static final int YES_OPTION = 0;
	public static final int NO_OPTION = 1;
	public static final int CANCEL_OPTION = 2;
	
	/**
	 * @param file
	 * @param parent
	 * @return FILE_NOT_FOUND(=-1) if file doesn't exists
	 *         YES_OPTION(=0) if yes selected
	 *         NO_OPTION(=1) if no selected
	 *         CANCEL_OPTION(=2) if cancel selected
	 */
	public static int confirmYesNoCancel(File file, Component parent, boolean cancelOption){
		if(file.exists()){
			int ret = JOptionPane.showConfirmDialog(
					parent, 
					file.getAbsolutePath()+" "+Messages.getString("ConfirmOverwrite.cofirm_overwrite"), //$NON-NLS-1$ //$NON-NLS-2$
					Messages.getString("ConfirmOverwrite.overwrite"), //$NON-NLS-1$
					(cancelOption)?JOptionPane.YES_NO_CANCEL_OPTION:JOptionPane.YES_NO_OPTION);
			switch(ret){
			case JOptionPane.YES_OPTION:
				return YES_OPTION;
			case JOptionPane.NO_OPTION:
				return NO_OPTION;
			case JOptionPane.CANCEL_OPTION:
				return CANCEL_OPTION;
			}
		}
		return FILE_NOT_FOUND;
	}
}
