package com.ef_prime.rflow.util;

import java.io.File;
import java.util.Collection;

public class ExtensionUtility {
	
	public static String addExtension(String file, String[] extension, String delegateExtension){
		
		boolean hit = false;
		for(int i = 0; i < extension.length; i++){
			String ext = (extension[i].startsWith("."))?extension[i]:"."+extension[i]; //$NON-NLS-1$ //$NON-NLS-2$
			if(file.toLowerCase().endsWith(ext.toLowerCase())){
				hit = true;
				break;
			}
		}
		if(!hit)
			file += (delegateExtension.startsWith("."))?delegateExtension:"."+delegateExtension; //$NON-NLS-1$ //$NON-NLS-2$
		
		return file;
	}
	
	public static String addExtension(String file, String extension){
		return addExtension(file, new String[]{extension}, extension);
	}
	
	public static String addExtension(String file, Collection<String> extension, String delegateExtension){
		return addExtension(file, extension.toArray(new String[extension.size()]), delegateExtension);
	}

	public static File addExtension(File file, String extension){
		String s = addExtension(file.getAbsolutePath(), extension);
		return new File(s);
	}
	public static File addExtension(File file, String[] extension, String delegateExtension){
		String s = addExtension(file.getAbsolutePath(), extension, delegateExtension);
		return new File(s);
	}
	public static File addExtension(File file, Collection<String> extension, String delegateExtension){
		String s = addExtension(file.getAbsolutePath(), extension, delegateExtension);
		return new File(s);
	}
	
	/**
	 * 拡張子を取り除いたファイル名を返します
	 * @param file
	 * @return
	 */
	public static String removeExtension(File file){
		return removeExtension(file.getName());
	}
	
	/**
	 * 拡張子を取り除いたファイルパスを返します
	 * @param file
	 * @return
	 */
	public static String removeExtension(String file){
		int index = file.lastIndexOf('.');
		if(index < 0)
			return file;
		return file.substring(0, index);
	}
	
	public static String getExtension(String file){
		int index = file.lastIndexOf('.');
		if(index < 0)
			return ""; //$NON-NLS-1$
		return file.substring(index+1, file.length());
	}
}
