package com.ef_prime.rflow.util;

import java.io.File;
import java.util.Collections;
import java.util.SortedSet;
import java.util.TreeSet;

import javax.swing.filechooser.FileFilter;

/**
 * 1.6より同じような役割を果たすFileNameExtensionFilter
 * が存在する。
 *
 */
public class MyFileFilter extends FileFilter {	
	SortedSet<String> extension;
	String delegateExtension;
	String description;
	
	public MyFileFilter(){
		extension = new TreeSet<String>();
		description = "file"; //$NON-NLS-1$
		delegateExtension = null;
	}
	
	@Override
	public boolean accept(File f) {	
		if(f == null){
			return false;
		}
		if(f.isDirectory()){
			return true;
		}
		String name = f.getName();
		int pos = name.lastIndexOf('.');
		if(pos == -1){
			return false;
		}
		String ext = name.substring(pos+1).toLowerCase();
		return extension.contains(ext);
	}

	@Override
	public String getDescription() {			
		return description;
	}
	
	public void setDescription(String description){
		if(description == null){
			return;
		}
		this.description = description;
	}
			
	public void addExtention(String ext){
		if(ext == null){
			return;
		}
		String lowExt = ext.toLowerCase();
		extension.add(lowExt);
	}
	
	public SortedSet<String> getExtension()
	{
		return Collections.unmodifiableSortedSet(extension);
	}
	
	public String getDelegateExtension(){
		if(delegateExtension == null)
			return extension.first();
		else
			return delegateExtension;
	}

	public void setDelegateExtension(String delegateExtension) {
		this.delegateExtension = delegateExtension;
	}
}	
