package com.ef_prime.rflow.util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

public class PropertiesUtility {
	
	public static void load(Properties p, File file) throws FileNotFoundException, IOException{
		InputStream in = new BufferedInputStream(new FileInputStream(file));
		try{
			p.load(in);
		}finally{
			in.close();
		}
	}
	
	public static void store(Properties p, File file) throws FileNotFoundException, IOException{
		OutputStream out = new BufferedOutputStream(new FileOutputStream(file));
		try{
			p.store(out, null);
		}finally{
			out.close();
		}
	}
	
	/**
	 * UTF-8の改行区切りの一覧ファイルを読み込みます
	 * @param f
	 * @return
	 * @throws IOException 
	 */
	public static List<String> readList(File f) throws IOException{
		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(f), "UTF-8")); //$NON-NLS-1$
		try{
			String line = null;
			ArrayList<String> list = new ArrayList<String>();
			while((line = reader.readLine()) != null){
				list.add(line);
			}
			return list;
		}finally{
			if(reader != null)
				reader.close();
		}
	}
	
	/**
	 * UTF-8の改行区切りの一覧ファイルにListを書き出します
	 * @param f
	 * @param list 
	 * @throws IOException 
	 */
	public static void writeList(File f, List<String> list) throws IOException{
		BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(f), "UTF-8")); //$NON-NLS-1$
		try{
			for(String s : list){
				writer.write(s);
				writer.newLine();
			}
		} finally {
			if(writer != null)
				writer.close();
		}
	}
}
