package com.ef_prime.rflow.util;

public class RandomStringUtility {
	
	/**
	 * [a-z0-9]からなる指定された文字数のランダムな文字列を作成します。
	 * 乱数の生成にはMath.randomを使用しています。
	 * @param length
	 * @return
	 */
	public static String getRandomAlphanumeric(int length){
		if(length < 0)
			throw new IllegalArgumentException("length must be >= 0"); //$NON-NLS-1$
		
		String ret = ""; //$NON-NLS-1$
		for(int i = 0; i < length; i++){
			int index = (int)Math.round(Math.random() * (10 + 26 - 1));
			if(index >= (10)){
				ret += ((char)((int)'a'+(index-(10))));
			}else{
				ret += ((char)((int)'0'+index));
			}
		}
		
		return ret;
	}
}
