package com.ef_prime.rflow.util;

import java.util.Iterator;
import java.util.Vector;

/**
 * 
 * TODO Vector以外の追加消去にコストのかからないデータ構造へのおきかえを検討
 *
 * @param <E>
 */
public class SizeLimitVector<E> implements Iterable<E>{
	
	private int sizeLimit;
	private Vector<E> delegate;
	
	public SizeLimitVector(int sizeLimit) {
		if(sizeLimit < 1)throw new IllegalArgumentException("sizeLimit must be > 0"); //$NON-NLS-1$
		
		this.sizeLimit = sizeLimit;
		delegate = new Vector<E>();
	}

	public boolean add(E e) {
		while(size() >= sizeLimit){
			remove(0);
		}
		return delegate.add(e);
	}

	public void clear() {
		delegate.clear();
	}

	public boolean equals(Object o) {
		return delegate.equals(o);
	}

	public E get(int index) {
		return delegate.get(index);
	}

	public int hashCode() {
		return delegate.hashCode();
	}

	public boolean isEmpty() {
		return delegate.isEmpty();
	}

	public Iterator<E> iterator() {
		return delegate.iterator();
	}

	public E remove(int index) {
		return delegate.remove(index);
	}

	public String toString() {
		return delegate.toString();
	}

	public int size() {
		return delegate.size();
	}

	public Object[] toArray() {
		return delegate.toArray();
	}

	public <T> T[] toArray(T[] a) {
		return delegate.toArray(a);
	}

}
