#include <jni.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <locale.h>
#include <R_ext/rlocale.h>
#include <R_ext/Riconv.h>

const char* UTF8 = "UTF-8";
char* LOCAL_CHAR = "UTF-8";

void UpdateLocalChar(){
	setlocale(LC_ALL, "");
	LOCAL_CHAR = locale2charset(NULL);
}

const char* GetStringLocalChars(JNIEnv *env, jstring str, jboolean *isCopy){
	const char* src;
	size_t srcLen;
	size_t destLen;
	void* cd;
	char *dest_buf;
	const char *s;
	char *d;
	
	src = (*env)->GetStringUTFChars(env, str, 0);
	
	s = src;
	srcLen = strlen(src)+1;
	
	if((dest_buf = (char *)calloc(srcLen*2, sizeof(char))) == NULL){
		fprintf(stderr, "out of memory");
		exit(1);
	}
	d = dest_buf;
	destLen = srcLen*2*sizeof(char);
	
	cd = Riconv_open(LOCAL_CHAR, UTF8);
	Riconv(cd, &s, &srcLen, &d, &destLen);
	Riconv_close(cd);
	
	(*env)->ReleaseStringUTFChars(env, str, src);
	
	return dest_buf;
}


void ReleaseStringLocalChars(JNIEnv *env, jstring string, const char* str){
	free((void *)str);
}

jstring NewStringLocal(JNIEnv *env, const char* str){
	size_t srcLen;
	size_t destLen;
	void* cd;
	const char *s;
	char *d;
	char *dest_buf;
	
	
	s = str;
	srcLen = strlen(str)+1;
	
	if((dest_buf = (char *)calloc(srcLen*2, sizeof(char))) == NULL){
		fprintf(stderr, "out of memory");
		exit(1);
	}
	d = dest_buf;
	destLen = srcLen*2*sizeof(char);
	
	cd = Riconv_open(UTF8, LOCAL_CHAR);
	Riconv(cd, &s, &srcLen, &d, &destLen);
	Riconv_close(cd);
	
	return (*env)->NewStringUTF(env, dest_buf);
}



